searchData={"items":[{"type":"module","title":"Geocoder","doc":"Geocoder is a simple, efficient geocoder/reverse geocoder with a built-in cache support","ref":"Geocoder.html"},{"type":"function","title":"Geocoder.call/1","doc":"","ref":"Geocoder.html#call/1"},{"type":"function","title":"Geocoder.call/2","doc":"","ref":"Geocoder.html#call/2"},{"type":"function","title":"Geocoder.call_list/2","doc":"","ref":"Geocoder.html#call_list/2"},{"type":"module","title":"Geocoder.Config","doc":"Centralization of configurations and defaults values.\n\nThe following options are available for configuration.\n\n  * `:pool_name` - The name for the pool.\n  * `:pool_config` - The configuration for the pool. It uses Poolboy behind the scene, so the following configuration key exists.\n  * `:store_module` - The store module to use. Defaults to `Geocoder.Store`\n  * `:store_config` - The store configuration\n  * `:worker_config` - The worker configuration. Things like the provider, key, or even custom JSON codec or HTTP clients\n\nHere is full example of a configuration (with all the defaults)\n\n```elixir\n[\n  pool_name: :geocoder_workers,\n  pool_config: [\n    worker_module: Geocoder.Worker,\n    size: 4,\n    max_overflow: 2,\n    strategy: :lifo,\n    name: {:local, :geocoder_workers}\n  ],\n  store_module: Geocoder.Store,\n  store_config: [name: :geocoder_store, precision: 6],\n  worker_config: [\n    provider: Geocoder.Providers.OpenStreetMaps,\n    key: nil,\n    http_client: Geocoder.HttpClient.Httpoison,\n    http_client_opts: [recv_timeout: 30000],\n    json_codec: Jason,\n    data: nil\n  ]\n]\n```","ref":"Geocoder.Config.html"},{"type":"function","title":"Geocoder.Config.all/1","doc":"","ref":"Geocoder.Config.html#all/1"},{"type":"function","title":"Geocoder.Config.default_pool_name/0","doc":"","ref":"Geocoder.Config.html#default_pool_name/0"},{"type":"function","title":"Geocoder.Config.default_store_name/0","doc":"","ref":"Geocoder.Config.html#default_store_name/0"},{"type":"function","title":"Geocoder.Config.pool_config/1","doc":"","ref":"Geocoder.Config.html#pool_config/1"},{"type":"function","title":"Geocoder.Config.pool_name/1","doc":"","ref":"Geocoder.Config.html#pool_name/1"},{"type":"function","title":"Geocoder.Config.store_config/1","doc":"","ref":"Geocoder.Config.html#store_config/1"},{"type":"function","title":"Geocoder.Config.store_module/1","doc":"","ref":"Geocoder.Config.html#store_module/1"},{"type":"function","title":"Geocoder.Config.worker_config/1","doc":"","ref":"Geocoder.Config.html#worker_config/1"},{"type":"type","title":"Geocoder.Config.geocoder_config/0","doc":"","ref":"Geocoder.Config.html#t:geocoder_config/0"},{"type":"type","title":"Geocoder.Config.geocoder_option/0","doc":"","ref":"Geocoder.Config.html#t:geocoder_option/0"},{"type":"type","title":"Geocoder.Config.pool_config/0","doc":"","ref":"Geocoder.Config.html#t:pool_config/0"},{"type":"type","title":"Geocoder.Config.pool_option/0","doc":"","ref":"Geocoder.Config.html#t:pool_option/0"},{"type":"type","title":"Geocoder.Config.store_config/0","doc":"","ref":"Geocoder.Config.html#t:store_config/0"},{"type":"type","title":"Geocoder.Config.store_option/0","doc":"","ref":"Geocoder.Config.html#t:store_option/0"},{"type":"type","title":"Geocoder.Config.worker_config/0","doc":"","ref":"Geocoder.Config.html#t:worker_config/0"},{"type":"type","title":"Geocoder.Config.worker_option/0","doc":"","ref":"Geocoder.Config.html#t:worker_option/0"},{"type":"behaviour","title":"Geocoder.HttpClient","doc":"Specifies expected behaviour of an HTTP client.\n\nGeocoder allows you to use your HTTP client of choice, provided that\nit can be coerced into complying with this module's specification.\n\nThe default client is `:httpoison`.\n\nOther supported clients:\n- Hackney:\n  Make sure to add the dependency to you `mix.exs` file\n\n  ```\n  {:hackney, \"~> 1.18\"},\n  ```\n- Httpoison:\n  Make sure to add the dependency to you `mix.exs` file\n\n  ```\n  {:httpoison, \"~> 2.1\"},\n  ```\n\nSee `lib/geocoder/http_client/http_poison.ex` for an implementation example\n\nWhen conforming your selected HTTP Client take note of a few things:\n\n  - The module name doesn't need to follow the same styling as this module it\n    is simply your own 'HTTP Client', i.e. `MyApp.HttpClient`\n\n  - The request function must accept the methods as described in the\n    `c:request/2` callback, you can however set these as optional,\n    i.e. `config \\ []`\n\n  - You will need to manage the body encoding and decoding properly\n    by using the the config[:json_codec] to keep it flexible\n\n  - You will need to manage the query_params encoding if needed. This depends\n    the internal client support for this\n\n  - Ensure the call to your chosen HTTP Client is correct and the return is\n    in the same format as defined in the `c:request/2` callback","ref":"Geocoder.HttpClient.html"},{"type":"callback","title":"Geocoder.HttpClient.request/2","doc":"","ref":"Geocoder.HttpClient.html#c:request/2"},{"type":"type","title":"Geocoder.HttpClient.config/0","doc":"","ref":"Geocoder.HttpClient.html#t:config/0"},{"type":"type","title":"Geocoder.HttpClient.http_method/0","doc":"","ref":"Geocoder.HttpClient.html#t:http_method/0"},{"type":"type","title":"Geocoder.HttpClient.option/0","doc":"","ref":"Geocoder.HttpClient.html#t:option/0"},{"type":"type","title":"Geocoder.HttpClient.request/0","doc":"","ref":"Geocoder.HttpClient.html#t:request/0"},{"type":"module","title":"Geocoder.HttpClient.Hackney","doc":"Hackney client. See Hackney for documentation for options that can be passed\nin the http_client_opts","ref":"Geocoder.HttpClient.Hackney.html"},{"type":"function","title":"Geocoder.HttpClient.Hackney.request/2","doc":"","ref":"Geocoder.HttpClient.Hackney.html#request/2"},{"type":"module","title":"Geocoder.HttpClient.Httpoison","doc":"HTTPoison client. See HTTPoison for documentation for options that can be passed\nin the http_client_opts","ref":"Geocoder.HttpClient.Httpoison.html"},{"type":"function","title":"Geocoder.HttpClient.Httpoison.request/2","doc":"","ref":"Geocoder.HttpClient.Httpoison.html#request/2"},{"type":"behaviour","title":"Geocoder.JSONCodec","doc":"Defines the specification for a JSON codec.\n\nGeocoder supports the use of your favorite JSON codec provided it fulfills this specification.\nJason fulfills this spec without modification, and is the default for now.\n\nOther codecs:\n- Jason:\n  Make sure to add the dependency to you `mix.exs` file\n\n  ```\n  {:jason, \"~> 1.4\"},\n  ```\n\n  In your config you would do:\n\n  ```elixir\n    config :geocoder,\n      json_codec: Jason\n  ```\n- JSX:\n    Make sure to add the dependency to you `mix.exs` file\n\n    ```\n    {:jsx, \"~> 2.8 or ~> 3.0\"},\n    ```\n\n    In your config you would do:\n\n    ```elixir\n      config :geocoder,\n      json_codec: Geocoder.JSON.JSX\n    ```\n- Poison:\n  Make sure to add the dependency to you `mix.exs` file\n\n  ```\n  {:poison, \"~> 5.0\"},\n  ```\n\n  In your config you would do:\n\n  ```elixir\n    config :geocoder,\n      json_codec: Poison\n  ```\n\nIf you need another one that does not match the specification, see the contents of `Geocoder.JSON.JSX` for an example of an alternative implementation.","ref":"Geocoder.JSONCodec.html"},{"type":"callback","title":"Geocoder.JSONCodec.decode/1","doc":"","ref":"Geocoder.JSONCodec.html#c:decode/1"},{"type":"callback","title":"Geocoder.JSONCodec.decode!/1","doc":"","ref":"Geocoder.JSONCodec.html#c:decode!/1"},{"type":"callback","title":"Geocoder.JSONCodec.encode/1","doc":"","ref":"Geocoder.JSONCodec.html#c:encode/1"},{"type":"callback","title":"Geocoder.JSONCodec.encode!/1","doc":"","ref":"Geocoder.JSONCodec.html#c:encode!/1"},{"type":"module","title":"Geocoder.JSONCodec.JSX","doc":"Implementation of the codec for the JSX library","ref":"Geocoder.JSONCodec.JSX.html"},{"type":"function","title":"Geocoder.JSONCodec.JSX.decode/1","doc":"","ref":"Geocoder.JSONCodec.JSX.html#decode/1"},{"type":"function","title":"Geocoder.JSONCodec.JSX.decode!/1","doc":"","ref":"Geocoder.JSONCodec.JSX.html#decode!/1"},{"type":"function","title":"Geocoder.JSONCodec.JSX.encode/1","doc":"","ref":"Geocoder.JSONCodec.JSX.html#encode/1"},{"type":"function","title":"Geocoder.JSONCodec.JSX.encode!/1","doc":"","ref":"Geocoder.JSONCodec.JSX.html#encode!/1"},{"type":"behaviour","title":"Geocoder.Provider","doc":"Specifies expected behaviour for a provider","ref":"Geocoder.Provider.html"},{"type":"callback","title":"Geocoder.Provider.geocode/2","doc":"","ref":"Geocoder.Provider.html#c:geocode/2"},{"type":"callback","title":"Geocoder.Provider.geocode_list/2","doc":"","ref":"Geocoder.Provider.html#c:geocode_list/2"},{"type":"callback","title":"Geocoder.Provider.reverse_geocode/2","doc":"","ref":"Geocoder.Provider.html#c:reverse_geocode/2"},{"type":"callback","title":"Geocoder.Provider.reverse_geocode_list/2","doc":"","ref":"Geocoder.Provider.html#c:reverse_geocode_list/2"},{"type":"type","title":"Geocoder.Provider.option/0","doc":"","ref":"Geocoder.Provider.html#t:option/0"},{"type":"type","title":"Geocoder.Provider.options/0","doc":"","ref":"Geocoder.Provider.html#t:options/0"},{"type":"type","title":"Geocoder.Provider.payload/0","doc":"","ref":"Geocoder.Provider.html#t:payload/0"},{"type":"module","title":"Geocoder.Request","doc":"This is the actual request logic to abstract a client implementation and use supported clients specified\nfor all providers in a uniform way.\n\nCommon logic (retry, etc) to clients should be added here. Otherwise let the client implement their own specific\nneeds","ref":"Geocoder.Request.html"},{"type":"function","title":"Geocoder.Request.request/2","doc":"","ref":"Geocoder.Request.html#request/2"},{"type":"module","title":"Geocoder.Store","doc":"Store is used as caching mechanism and is currently implemented as an in memory storage\nso within an Elixir process basically","ref":"Geocoder.Store.html"},{"type":"function","title":"Geocoder.Store.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Geocoder.Store.html#child_spec/1"},{"type":"function","title":"Geocoder.Store.geocode/2","doc":"","ref":"Geocoder.Store.html#geocode/2"},{"type":"function","title":"Geocoder.Store.init/1","doc":"","ref":"Geocoder.Store.html#init/1"},{"type":"function","title":"Geocoder.Store.link/3","doc":"","ref":"Geocoder.Store.html#link/3"},{"type":"function","title":"Geocoder.Store.reverse_geocode/2","doc":"","ref":"Geocoder.Store.html#reverse_geocode/2"},{"type":"function","title":"Geocoder.Store.start_link/1","doc":"","ref":"Geocoder.Store.html#start_link/1"},{"type":"function","title":"Geocoder.Store.state/1","doc":"","ref":"Geocoder.Store.html#state/1"},{"type":"function","title":"Geocoder.Store.update/2","doc":"","ref":"Geocoder.Store.html#update/2"},{"type":"module","title":"Geocoder.Supervisor","doc":"Supervisor for the Geocoder Worker pool and Geocoder Store. See `Geocoder.Config` for details\non the configurations and the possible values","ref":"Geocoder.Supervisor.html"},{"type":"module","title":"Configuration Example to use a different provider (google) - Geocoder.Supervisor","doc":"```elixir\n  Supervisor.start_link(worker_config: [provider: Geocoder.Providers.Google])\n```","ref":"Geocoder.Supervisor.html#module-configuration-example-to-use-a-different-provider-google"},{"type":"module","title":"Configuration Example to use a different HttpClient - Geocoder.Supervisor","doc":"```elixir\n  Supervisor.start_link(worker_config: [http_client: MyApp.MyClient, http_client_opts: [timeout: 1]])\n```","ref":"Geocoder.Supervisor.html#module-configuration-example-to-use-a-different-httpclient"},{"type":"function","title":"Geocoder.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Geocoder.Supervisor.html#child_spec/1"},{"type":"function","title":"Geocoder.Supervisor.start_link/1","doc":"","ref":"Geocoder.Supervisor.html#start_link/1"},{"type":"module","title":"Geocoder.Worker","doc":"Worker the actual process performing the geocoding request to a provider. They are use\nwithin a pool (using Poolboy. See Supervisor for details)\n\nSome options are can be passed as part of params such as\n\n  * `:timeout` - The request timeout in milliseconds. Default to 5000 milliseconds\n  * `:stream_to` - When specified, an async request will be made and result sent to the value specified.\n     It also implies the  HTTP client supports streaming.\n  * `:store` - Wether to use the cache store or not. Default to true. So always checking the cache first","ref":"Geocoder.Worker.html"},{"type":"function","title":"Geocoder.Worker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Geocoder.Worker.html#child_spec/1"},{"type":"function","title":"Geocoder.Worker.geocode/1","doc":"","ref":"Geocoder.Worker.html#geocode/1"},{"type":"function","title":"Geocoder.Worker.geocode_list/1","doc":"","ref":"Geocoder.Worker.html#geocode_list/1"},{"type":"function","title":"Geocoder.Worker.init/1","doc":"","ref":"Geocoder.Worker.html#init/1"},{"type":"function","title":"Geocoder.Worker.reverse_geocode/1","doc":"","ref":"Geocoder.Worker.html#reverse_geocode/1"},{"type":"function","title":"Geocoder.Worker.reverse_geocode_list/1","doc":"","ref":"Geocoder.Worker.html#reverse_geocode_list/1"},{"type":"function","title":"Geocoder.Worker.start_link/1","doc":"","ref":"Geocoder.Worker.html#start_link/1"},{"type":"module","title":"Geocoder.Providers.Fake","doc":"A fake provider mostly use for testing purpose","ref":"Geocoder.Providers.Fake.html"},{"type":"function","title":"Geocoder.Providers.Fake.geocode/2","doc":"","ref":"Geocoder.Providers.Fake.html#geocode/2"},{"type":"function","title":"Geocoder.Providers.Fake.geocode_from_config/2","doc":"","ref":"Geocoder.Providers.Fake.html#geocode_from_config/2"},{"type":"function","title":"Geocoder.Providers.Fake.geocode_list/2","doc":"","ref":"Geocoder.Providers.Fake.html#geocode_list/2"},{"type":"function","title":"Geocoder.Providers.Fake.get_worker_config/1","doc":"","ref":"Geocoder.Providers.Fake.html#get_worker_config/1"},{"type":"function","title":"Geocoder.Providers.Fake.reverse_geocode/2","doc":"","ref":"Geocoder.Providers.Fake.html#reverse_geocode/2"},{"type":"function","title":"Geocoder.Providers.Fake.reverse_geocode_from_config/2","doc":"","ref":"Geocoder.Providers.Fake.html#reverse_geocode_from_config/2"},{"type":"function","title":"Geocoder.Providers.Fake.reverse_geocode_list/2","doc":"","ref":"Geocoder.Providers.Fake.html#reverse_geocode_list/2"},{"type":"module","title":"Geocoder.Providers.GoogleMaps","doc":"Google Map provider logic. Google requires a key\n\nSee documentation details at https://developers.google.com/maps/documentation/geocoding/","ref":"Geocoder.Providers.GoogleMaps.html"},{"type":"function","title":"Geocoder.Providers.GoogleMaps.geocode/2","doc":"","ref":"Geocoder.Providers.GoogleMaps.html#geocode/2"},{"type":"function","title":"Geocoder.Providers.GoogleMaps.geocode_list/2","doc":"","ref":"Geocoder.Providers.GoogleMaps.html#geocode_list/2"},{"type":"function","title":"Geocoder.Providers.GoogleMaps.reverse_geocode/2","doc":"","ref":"Geocoder.Providers.GoogleMaps.html#reverse_geocode/2"},{"type":"function","title":"Geocoder.Providers.GoogleMaps.reverse_geocode_list/2","doc":"","ref":"Geocoder.Providers.GoogleMaps.html#reverse_geocode_list/2"},{"type":"module","title":"Geocoder.Providers.OpenCageData","doc":"Open Cage Data provider logic. Open Cage Data requires a key\n\nSee documentation details at https://opencagedata.com/api","ref":"Geocoder.Providers.OpenCageData.html"},{"type":"function","title":"Geocoder.Providers.OpenCageData.geocode/2","doc":"","ref":"Geocoder.Providers.OpenCageData.html#geocode/2"},{"type":"function","title":"Geocoder.Providers.OpenCageData.geocode_list/2","doc":"","ref":"Geocoder.Providers.OpenCageData.html#geocode_list/2"},{"type":"function","title":"Geocoder.Providers.OpenCageData.reverse_geocode/2","doc":"","ref":"Geocoder.Providers.OpenCageData.html#reverse_geocode/2"},{"type":"function","title":"Geocoder.Providers.OpenCageData.reverse_geocode_list/2","doc":"","ref":"Geocoder.Providers.OpenCageData.html#reverse_geocode_list/2"},{"type":"module","title":"Geocoder.Providers.OpenStreetMaps","doc":"OpenStreetMaps provider logic. Does not requires a key\n\nSee documentation details at https://nominatim.org/release-docs/develop/api/Overview/","ref":"Geocoder.Providers.OpenStreetMaps.html"},{"type":"function","title":"Geocoder.Providers.OpenStreetMaps.geocode/2","doc":"","ref":"Geocoder.Providers.OpenStreetMaps.html#geocode/2"},{"type":"function","title":"Geocoder.Providers.OpenStreetMaps.geocode_list/2","doc":"","ref":"Geocoder.Providers.OpenStreetMaps.html#geocode_list/2"},{"type":"function","title":"Geocoder.Providers.OpenStreetMaps.reverse_geocode/2","doc":"","ref":"Geocoder.Providers.OpenStreetMaps.html#reverse_geocode/2"},{"type":"function","title":"Geocoder.Providers.OpenStreetMaps.reverse_geocode_list/2","doc":"","ref":"Geocoder.Providers.OpenStreetMaps.html#reverse_geocode_list/2"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"In the interest of fostering an open and welcoming environment, we as\ncontributors and maintainers pledge to making participation in our project and\nour community a harassment-free experience for everyone, regardless of age, body\nsize, disability, ethnicity, gender identity and expression, level of experience,\nnationality, personal appearance, race, religion, or sexual identity and\norientation.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to creating a positive environment\ninclude:\n\n* Using welcoming and inclusive language\n* Being respectful of differing viewpoints and experiences\n* Gracefully accepting constructive criticism\n* Focusing on what is best for the community\n* Showing empathy towards other community members\n\nExamples of unacceptable behavior by participants include:\n\n* The use of sexualized language or imagery and unwelcome sexual attention or\nadvances\n* Trolling, insulting/derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or electronic\n  address, without explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Our Responsibilities - Code of Conduct","doc":"Project maintainers are responsible for clarifying the standards of acceptable\nbehavior and are expected to take appropriate and fair corrective action in\nresponse to any instances of unacceptable behavior.\n\nProject maintainers have the right and responsibility to remove, edit, or\nreject comments, commits, code, wiki edits, issues, and other contributions\nthat are not aligned to this Code of Conduct, or to ban temporarily or\npermanently any contributor for other behaviors that they deem inappropriate,\nthreatening, offensive, or harmful.","ref":"code_of_conduct.html#our-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies both within project spaces and in public spaces\nwhen an individual is representing the project or its community. Examples of\nrepresenting a project or community include using an official project e-mail\naddress, posting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event. Representation of a project may be\nfurther defined and clarified by project maintainers.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported by contacting the project maintainers ([knrz][maintainer_knrz],\n[carpodaster][maintainer_carp]). All complaints will be reviewed and\ninvestigated and will result in a response that is deemed necessary and\nappropriate to the circumstances. The project team is obligated to maintain\nconfidentiality with regard to the reporter of an incident. Further details of\nspecific enforcement policies may be posted separately.\n\nProject maintainers who do not follow or enforce the Code of Conduct in good\nfaith may face temporary or permanent repercussions as determined by other\nmembers of the project's leadership.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4,\navailable at [http://contributor-covenant.org/version/1/4][version]\n\n[homepage]: http://contributor-covenant.org\n[version]: http://contributor-covenant.org/version/1/4/\n[maintainer_knrz]: https://github.com/knrz\n[maintainer_carp]: https://github.com/carpodaster","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"License","doc":"# MIT License\n\nCopyright (c) 2015 Kash Nouroozi\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Geocoder\n\n[![Build Status](https://github.com/knrz/geocoder/actions/workflows/elixir.yml/badge.svg)](https://github.com/knrz/geocoder/actions/workflows/elixir.yml)\n[![Inline docs](http://inch-ci.org/github/knrz/geocoder.svg?branch=master)](http://inch-ci.org/github/knrz/geocoder)\n[![Coverage Status](https://coveralls.io/repos/github/knrz/geocoder/badge.svg?branch=master)](https://coveralls.io/github/knrz/geocoder?branch=master)\n[![Module Version](https://img.shields.io/hexpm/v/geocoder.svg)](https://hex.pm/packages/geocoder)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/geocoder/)\n[![Total Download](https://img.shields.io/hexpm/dt/geocoder.svg)](https://hex.pm/packages/geocoder)\n[![License](https://img.shields.io/hexpm/l/geocoder.svg)](https://github.com/knrz/geocoder/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/knrz/geocoder.svg)](https://github.com/knrz/geocoder/commits/master)\n\nA simple, efficient geocoder/reverse geocoder with a built-in cache. This libary is quite felxible and extensible. You can pretty much extend any part of geocoder: caching store, workers, http client, JSON Codec, Provider, etc..\n\nIt supports the current providers out of box\n- Google map\n- OpenCageData\n- Openstreet maps\n\nIt supports the current http clients out of the box\n- :httpoison\n- :hackney\n\nIt supports the current JSON clients out of the box\n- :jason\n- :jsx\n\nIt supports the current caching store out of the box\n- In memory store (`Geocoder.Store`)","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"add `:geocoder` to your `mix.exs` dependencies:\n\n```elixir\ndef deps do\n  [\n    {:geocoder, \"~> 2.0\"}\n  ]\nend\n```\n\nUpdate your mix dependencies:\n\n```bash\nmix deps.get\n```\n\n**Notes:** If you are Elixir < 1.9, you'll need to use a version before `1.0`.","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Overview","doc":"Configuration is done by passing options to the `Geocoder.Supervisor`. See the `Geocoder.Config` for all possible configuration options. But you can just get started\nby adding this to your application tree\n\n```elixir\n[\n  Geocoder.Supervisor,\n]\n```\n\nThis will start the geocoder processes with all the default options, and should be compatible with 1.x (process + API + functionality)","ref":"readme.html#configuration"},{"type":"extras","title":"Using a different Provider - Overview","doc":"The default client for Geocoder is OpenStreeMaps. You can easily switch to other providers  option. Or you can build your own as long as you implement the behavior `Geocoder.Provider` correctly. You can look at some examples inside the `lib/geocoder/providers/*`\n\nThen you can configure the different or custom provider with the following configuration:\n\n```elixir\n[\n  {Geocoder.Supervisor, worker_config: [provider: MyApp.Client,  key: \"some_api_key\"]},\n]\n```\n**NOTES**: OpenStreetMaps does not require key. Others provider do.","ref":"readme.html#using-a-different-provider"},{"type":"extras","title":"Using a different HTTP Client - Overview","doc":"The default client for Geocoder is HTTPoison. You can easily switch to Hackney as it comes as an option. Or you can build your own as long as you implement the behavior `Geocoder.HttpClient` correctly in your client\n\n\nThen you can configure the different or custom client with the following configuration:\n\n```elixir\n[\n  {Geocoder.Supervisor, worker_config: [http_client: MyApp.Client,  http_client_opts: []]}\n]\n```\n\nIf you need to set a proxy (or any other option supported by `HTTPoison.get/3`):\n\n```elixir\n[\n  {Geocoder.Supervisor, worker_config:\n    [\n      http_client_opts: [proxy: \"my.proxy.server:3128\", proxy_auth: {\"username\", \"password\"}]\n    ]\n   }\n  ...\n]\n```","ref":"readme.html#using-a-different-http-client"},{"type":"extras","title":"Using a different Store - Overview","doc":"The default caching store is `Geocoder.Store`. This is a simple in memory cache (in a process basically) and is started by default.\n\nIf you want to change the Store, you can provide your own store implementation as well. See how the `Geocoder.Store` is implemented for an example. Then you will need to configure it using:\n\n```elixir\n[\n  {Geocoder.Supervisor, store_module: MyApp.MyStore},\n  ...\n]\n```","ref":"readme.html#using-a-different-store"},{"type":"extras","title":"JSON Codec Configuration - Overview","doc":"The default JSON codec is Jason. You can create you custom codec or use different one as long as you implement the behavior `Geocoder.JSONCodec`.\n\nThen you can configure the different or custom JSON codec with the following configuration:\n\n```elixir\n[\n  {Geocoder.Supervisor, worker_config:\n    [\n      json_codec: Jason\n    ]\n   }\n  ...\n]\n```","ref":"readme.html#json-codec-configuration"},{"type":"extras","title":"Usage - Overview","doc":"```elixir\n{:ok, coordinates } = Geocoder.call(\"Toronto, ON\")\n{:ok, coordinates } = Geocoder.call({43.653226, -79.383184})\n\ncoordinates.location.formatted_address\n```\n\nYou can pass options to the function that will be passed to the geocoder provider, for example:\n\n```elixir\nGeocoder.call(address: \"Toronto, ON\", language: \"es\", key: \"...\", ...)\n```\n\nYou can also change the provider on a per-call basis:\n\n```elixir\n{:ok, coordinates } =\n  with\n    # use the default provider\n    {:error, nil} <- Geocoder.call(query),\n    # use an alternative provider. If `key` is not specified here the globally defined key will be used.\n    {:error, nil} <- Geocoder.call(query, worker_config: [provider: Geocoder.Providers.OpenCageData, key: \"123\"]),\n    do: {:error}\n```\n\nSee [here](https://developers.google.com/maps/documentation/geocoding/intro#geocoding) and [here](https://developers.google.com/maps/documentation/geocoding/intro#ReverseGeocoding) for a list of supported parameters for the google maps geocoder provider (`Geocoder.Provider.GoogleMaps`).\n\nAnd you're done! How simple was that?","ref":"readme.html#usage"},{"type":"extras","title":"Development - Overview","doc":"Right now, `:geocoder` supports three external providers (i.e. sources):\n\n* `Geocoder.Providers.GoogleMaps`\n* `Geocoder.Providers.OpenCageData`\n* `Geocoder.Providers.OpenStreetMaps`\n\nTo run the tests for these, and any future providers, you'll want to pass a `PROVIDER` environment variable as well as the `API_KEY`:\n\n```shell\nPROVIDER=google API_KEY=\"mykey\" mix test\n```\n\nBy default, the tests against the [`Fake`](./lib/geocoder/providers/fake.ex) provider.\n\nTo avoid making external requests in the context of the test suite, usage of the [`Fake`](./lib/geocoder/providers/fake.ex) provider is recommended.\n\nThe fake provider can be configured by adding a `:data` tuple to the configuration as shown below.\n\nThe keys of the data map must be in either [regex](https://hexdocs.pm/elixir/Regex.html) or\n[tuple](https://hexdocs.pm/elixir/Tuple.html) format (specifically a `{lat, lng}` style pair of floats).\n\n```elixir\n[\n  {Geocoder.Supervisor, worker_config:\n    [\n      data: %{\n        ~r/.*New York, NY.*/ => %{\n          lat: 40.7587905,\n          lon: -73.9787755,\n          bounds: %{\n            bottom: 40.7587405,\n            left: -73.9788255,\n            right: -73.9787255,\n            top: 40.7588405,\n          },\n          location: %{\n            city: \"New York\",\n            country: \"United States\",\n            country_code: \"us\",\n            county: \"New York County\",\n            formatted_address: \"30 Rockefeller Plaza, New York, NY 10112, United States of America\",\n            postal_code: \"10112\",\n            state: \"New York\",\n            street: \"Rockefeller Plaza\",\n            street_number: \"30\"\n          },\n        },\n        {40.7587905, -73.9787755} => %{\n          lat: 40.7587905,\n          lon: -73.9787755,\n          bounds: %{\n            bottom: 40.7587405,\n            left: -73.9788255,\n            right: -73.9787255,\n            top: 40.7588405,\n          },\n          location: %{\n            city: \"New York\",\n            country: \"United States\",\n            country_code: \"us\",\n            county: \"New York County\",\n            formatted_address: \"30 Rockefeller Plaza, New York, NY 10112, United States of America\",\n            postal_code: \"10112\",\n            state: \"New York\",\n            street: \"Rockefeller Plaza\",\n            street_number: \"30\"\n          },\n        }\n      }\n    ]\n   }\n  ...\n]\n```","ref":"readme.html#development"},{"type":"extras","title":"Related & Alternative Packages - Overview","doc":"* https://github.com/amotion-city/lib_lat_lon\n* https://github.com/navinpeiris/geoip\n* https://github.com/elixir-geolix/geolix","ref":"readme.html#related-alternative-packages"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2023 Cyrus Nouroozi\n\nThe source code is licensed under the [MIT License](./LICENSE.md).","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Changelog","doc":"[Unreleased]\n\n[2.1.0] - 2024-12-16","ref":"changelog.html"},{"type":"extras","title":"Changes - Changelog","doc":"- Change minimum Elixir version to 1.14 as 1.13 is about to be no longer supported\n- Package updates\n- Support default worker configuration\n- Fix some missing typespecs\n\n[2.0.1] - 2023-08-18","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - Changelog","doc":"- Updates Copyright\n\n[2.0.0] - 2023-08-10\n\n** BREAKING**\n\nThis version will break how the geocoder starts. While we have kept the API similar and proposed a forward change, you will still need to add geocoder to your application tree. See changes below on how to migrate.","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - Changelog","doc":"- Rearchitected per the the [Elixir recommendation](https://hexdocs.pm/elixir/library-guidelines.html#avoid-spawning-unsupervised-processes) as well as [Chris Keathley](https://keathley.io/blog/reusable-libraries.html). No more an application is started. Instead a `Geocoder.Supervisor` was created to supervise the necessary processes. Also all configurations are now removed from the :geocoder application. Instead it is all specified in the supervisor allowing for more flexibility and to even start multiple pools\n- Added support for configurable http client. Currently implemented out of the box HTTPoison and Hackney. Defaults to HTTPoison.\n- Added support for configurable JSON codec. Currently implemented out of the box Json and JSX. Defaults to Jason.\n- Support multiple parallel supervisor (so you can potentially use multiple provider, each with their own pool)\n- Consolidated configuration to not use Application.get_env\n- Improved documentation in general\n- Cleanup code and configured Credo to improve maintenance","ref":"changelog.html#changes"},{"type":"extras","title":"Migrating from 1.x versions - Changelog","doc":"1. add to your supervising tree the geocoder supervisor\n2. Convert your configuration to the new format (the one you had under `config :geocoder, ...`)\n3. Remove all the `config :geocoder, ...` from your config/*\n\nthat's it! should just work out of the box as we will default the processes name for you to be compatible.\n\n[1.1.6] - 2023-07-23","ref":"changelog.html#migrating-from-1-x-versions"},{"type":"extras","title":"Changes - Changelog","doc":"- Update package dependencies (Towel)\n- Add partial_match on Geocoder Response by @dev-cruz in #93\n\n[1.1.5] - 2022-08-24","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - Changelog","doc":"- Misc doc changes by @kianmeng in #67\n- Fix store child spec to accept config by @ckhrysze in #73\n- Increase precision default by @sfusato in #91\n\n[1.1.4] - 2021-09-15","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - Changelog","doc":"- Fix store child spec to accept config by @ckhrysze in #73\n\n[1.1.3] - 2021-09-03","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - Changelog","doc":"- Add elixir 1.12 to test suite by in #72\n- Add support for suburbs to OpenSteetMaps by @iloveitaly and @ancyturtle in #71\n\n[1.1.2] - 2021-05-17","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - Changelog","doc":"- Elixir 1.11 support\n\nFor any  prior versions, see github commit directly","ref":"changelog.html#changes"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}